import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;

/**
 * I am co-dependent so I do whatever 
 * computer tells me to do
 * 
 * @author Tris10 Nolt (with some help) 
 * @version 1.0
 */
public class Counter extends Actor
{
     private static final Color transparent = new Color(0,0,0,0);
    private GreenfootImage background;
    public static int value;
    private int target;
    
       

    /**
     * Create a new counter, initialised to 0.
     */
    public Counter()
    {
        background = getImage();  // get image from class
        value = 0;
        target = 0;
        updateImage();
    }
    
    /**
     * Animate the display to count up (or down) to the current target value.
     */
    public void act() 
    {
        Cyberspace world = (Cyberspace) getWorld();
        if (value < 0)
        {
            // world.showText("Download Failed!",450,300);
            // Greenfoot.stop();
            // world.music.stop();
            // Greenfoot.playSound("gameover.mp3");
            add(1);
            
        }
        
        if (value == 100)
        {
            world.showText("Download Complete",450,300);
            Greenfoot.stop();
            
            getWorld().removeObjects(getWorld().getObjects(Worm.class));
            getWorld().removeObjects(getWorld().getObjects(BatteryPack.class));
            getWorld().removeObjects(getWorld().getObjects(Power.class));
            getWorld().removeObjects(getWorld().getObjects(Downloader.class));
            getWorld().removeObjects(getWorld().getObjects(Hacker.class));
            getWorld().removeObjects(getWorld().getObjects(Worm.class));
            world.low.stop();
            world.music.stop();
            Greenfoot.playSound("levelup.mp3");
        }
        
        if (value < target) {
            value++;
            updateImage();
        }
        else if (value > target) {
            value--;
            updateImage();
        }
    }

    /**
     * Add a new score to the current counter value.
     */
    public void add(int score)
    {
        target += score;
    }

    /**
     * Return the current counter value.
     */
    public int getValue()
    {
        return value;
    }

    /**
     * Set a new counter value.
     */
    public void setValue(int newValue)
    {
        target = newValue;
        value = newValue;
        updateImage();
    }

    /**
     * Update the image on screen to show the current value.
     */
    private void updateImage()
    {
        Cyberspace world = (Cyberspace) getWorld();
        GreenfootImage image = new GreenfootImage(background);
        GreenfootImage text = new GreenfootImage( value+ "%" , 22, Color.CYAN, transparent);
        image.drawImage(text, (image.getWidth()-text.getWidth())/2, 
                        (image.getHeight()-text.getHeight())/2);
        setImage(image);
    }
    }    

