import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)


/**
 * CyberSpace (N)
 * 
 * sībər - spās
 * 
 * a place for computers to downlaod files
 * and for hackers to delete files, and worms to 
 * destroy files, and power buttons to 
 * shutdown computers
 * 
 * @author Tris10 Nolt 
 * @version 1.0
 */
public class Cyberspace extends World
{
    
    public int time = 6000;
    public int Lives = 5;
    
    GreenfootSound music = new GreenfootSound("Boss.mp3");
    GreenfootSound low = new GreenfootSound("low.mp3");
    /**
     * I'm a world. What else is there to say.
     */
    public void act()
    {
        countTime();
        showLives();
        Greenfoot.setSpeed(48);
        if(time == 650)
        {
            removeObjects(getObjects(BatteryPack.class));
            
        }
        
        if (Greenfoot.getRandomNumber(1000) < 5)
        {
            addObject(new Power(), 900, Greenfoot.getRandomNumber(375));
        }
        
        
        if (time > 650)
        {
            if (Greenfoot.getRandomNumber(1000) == 2)
             {
                 addObject(new BatteryPack(), 900, Greenfoot.getRandomNumber(375));
                }
        }
    }
    
    /**
     * I want to be 900x500 pixels
     */
    public Cyberspace()
    {    
        // Create a new world with 900x550 cells with a cell size of 1x1 pixels.
        super(900, 550, 1); 
        prepare();
    }
    
    /**
     * A world without time! NEVER!
     */
    public void countTime()
    {
        
        
            time--;
        
        showTime();
        if(time > 6000)
        {
            time = 5800;
        }
        
        
        if(time == 5998)
        {
            Greenfoot.playSound("ready.mp3");
            showText("Get Ready!",450,225);
            Greenfoot.delay(40);
            
            
        }
        
        if(time == 5997)
        {
            
            showText(" ",450,225);
            Greenfoot.delay(15);
            
            
        }
        
        if(time == 5996)
        {
            
            showText("Get Ready",450,225);
            Greenfoot.delay(40);
            
            
        }
        
        if(time == 5995)
        {
            
            showText(" ",450,225);
            Greenfoot.delay(15);
            
            
        }
        
        if(time == 5994)
        {
            
            showText("Get Set",450,225);
            Greenfoot.delay(40);
            
            
        }
        
        if(time == 5993)
        {
            
            showText(" ",450,225);
            Greenfoot.delay(15);
            
            
        }
        
        if(time == 5992)
        {
            
            showText("Get Set",450,225);
            Greenfoot.delay(40);
            
            
        }
        
        if(time == 5991)
        {
            
            showText("Go!!! ",450,225);
            Greenfoot.delay(50);
            
            
        }
        
        
        
        
        
        if(time==5990)
        {
            music.playLoop();
            showText(" ",450,225);
            
        }
        
        if(time == 1500)
        {
            Greenfoot.playSound("warning.mp3");
        }
        
        if (time == 600)
        {
            
            low.play();
            music.stop();
            
        }
        
        if(time==0)
        {
            Greenfoot.stop();
            showText("Out of Battery!",450,300);
            music.stop();
            
            Greenfoot.playSound("logoff.mp3");
            Greenfoot.playSound("battery.mp3");
        }
    }
    
    
    
    public void addTime(int seconds)
    {
        time = time + seconds;
        showTime();
        
        
    }
    
    /**
     * A world that doesn't tell you the time. USELESS!
     */
    public void showTime()
    {
        showText(time/60 + "%" ,500,500);
    }
    
    
    
    /**
     * every world has to keep track of lives, so no one cheats
     */
    public void addLives(int Hearts)
    {
        Lives = Lives + Hearts;
        showLives();
    }
    
    /**
     * if the computer gets to many power 
     * buttons I will tell it to shutdown
     */
    public void showLives()
    {
        if(Lives == 5)
        {
            showText("OK" ,800,500);
        }
        
        if(Lives == 4)
        {
            showText("Awake" ,800,500);
        }
        
        if(Lives == 3)
        {
            showText("Standby" ,800,500);
        }
        
        if(Lives == 2)
        {
            showText("Sleep" ,800,500);
        }
        
        if(Lives == 1)
        {
            showText("Hibernate" ,800,500);
        }
        
        if(Lives == 0)
        {
            showText("Shutdown" ,800,500);
            Greenfoot.stop();
            showText("Your Computer Has Been Shutdown!",450,300);
            music.stop();
            low.stop();
            
            
            Greenfoot.playSound("logoff.mp3");
        }
    }
    
    

    /**
     * put the computer in the middle and add a few
     * downloaders, hackers and worms around it
     */
    private void prepare()
    {

        setPaintOrder(Starter.class,Computer.class,Downloader.class,Worm.class,Hacker.class,Power.class);

        Counter counter = new Counter();
        addObject(counter,464,43);

        Computer computer = new Computer(counter);
        addObject(computer,453,286);

        Downloader downloader = new Downloader();
        addObject(downloader,698,150);
        Downloader downloader2 = new Downloader();
        addObject(downloader2,707,391);
        Downloader downloader3 = new Downloader();
        addObject(downloader3,185,452);
        Downloader downloader4 = new Downloader();
        addObject(downloader4,153,193);

        Hacker hacker = new Hacker();
        addObject(hacker,793,76);
        Hacker hacker2 = new Hacker();
        addObject(hacker2,805,369);
        Hacker hacker3 = new Hacker();
        addObject(hacker3,354,491);
        Hacker hacker4 = new Hacker();
        addObject(hacker4,157,72);

        Worm worm = new Worm();
        addObject(worm,576,158);
        Worm worm2 = new Worm();
        addObject(worm2,524,476);
        Worm worm3 = new Worm();
        addObject(worm3,216,355);
        Worm worm4 = new Worm();
        addObject(worm4,679,70);
        Worm worm5 = new Worm();
        addObject(worm5,811,231);

        Starter starter = new Starter();
        addObject(starter,319,286);

        loader loader = new loader();
        addObject(loader,505,43);

        Battery battery = new Battery();
        addObject(battery,504,501);
        Downloader downloader5 = new Downloader();
        addObject(downloader5,634,182);
        Worm worm6 = new Worm();
        addObject(worm6,704,45);
        
        
        
        starter.setLocation(458,278);
    }
}
